
(* #load "str.cmxa";; *)
(* #load "scripts/model.ml";; *)

open Str
open String
open Model


(*let hA = Hashtbl.create 1000 ;;*)
let mM = Model.create 1000;;
let mL = Model.create 1000;;
let mH = Model.create 1000;;


(* read loop *)
try
  while true do
    let s = input_line stdin in
    if (string_match (regexp "^M \\(.*\\) \\(.*\\) \\(.*\\):\\(.*\\){e\\(.*\\)} : \\(.*\\):\\(.*\\) \\(.*\\):\\(.*\\) = \\(.*\\)") s 0) then
      let u_  = matched_group 1 s in
      let d_  = matched_group 2 s in
      let l_  = matched_group 3 s in
      let c_  = matched_group 4 s in
      let i_  = matched_group 5 s in
      let l_0 = matched_group 6 s in
      let c_0 = matched_group 7 s in
      let l_1 = matched_group 8 s in
      let c_1 = matched_group 9 s in
      let pr  = matched_group 10 s in
      Model.set mM (lowercase u_,d_,l_,c_,int_of_string i_) (l_0,c_0,l_1,c_1) (float_of_string pr)
    else if (string_match (regexp "^L \\([^ ]*\\) e\\([^ ]*\\) : e\\([^ ]*\\) = \\([^ ]*\\)") s 0) then
      let l_i = matched_group 1 s in
      let i_  = matched_group 2 s in
      let i_i = matched_group 3 s in
      let pr  = matched_group 4 s in
      Model.set mL (l_i,int_of_string i_) (int_of_string i_i) (float_of_string pr)
    else if (string_match (regexp "^H \\([^ ]*\\) e\\([^ ]*\\) : \\([^ ]*\\) = \\([^ ]*\\)") s 0) then
      let c = matched_group 1 s in
      let i = matched_group 2 s in
      let h = matched_group 3 s in
      let pr = matched_group 4 s in
      Model.set mH (c,int_of_string i) h (float_of_string pr)
    else (
    )
  done;
  None
with
  End_of_file -> None
;;

let mGRLzero = Model.create 1000;;

(print_endline "proc\n");
;;


(* calc left expansion probs (sum over right child): M0 *)
let mM0 = Model.create 1000;;
Model.foreach mM
  (fun (u_,d_,l_,c_,i_) (l_0,c_0,l_1,c_1) prM ->
    Model.add mM0 (u_,d_,l_,c_,i_) (l_0,c_0) prM
  )
;;

(* calc left expansion with M and L together: G0 *)
let mG0 = Model.create 1000;;
Model.foreach mM0
  (fun (u_,d_,l_,c_,i_) (l_0,c_0) prM0 ->
    Model.foreach_given mL (l_0,i_)
      (fun i_0 prL ->
        Model.add mG0 (u_,d_,l_,c_,i_) (l_0,c_0,i_0) (prM0 *. prL)
      )
  )
;;


(* WRONG!!!!!! *)
(* calc base case: GRL^0 *)
Model.foreach mM
  (fun (u_,d_,l_,c_,i_) (l_0,c_0,l_1,c_1) prM ->
    Model.foreach_given mL (l_0,i_)
      (fun i_0 prL ->
        Model.set mGRLzero (d_,l_,c_,i_) (l_0,c_0,i_0) (prM *. prL)
      ) 
  )
;;

(*(* echo out GRL^0 *)*)
(*Model.foreach mGRLzero*)
(*  (fun (d_,l_,c_,i_) (l_0,c_0,i_0) pr ->*)
(*    print_endline ("GRL0 "^d_^" "^l_^":"^c_^"{e"^(string_of_int i_)^"} : "^l_0^":"^c_0^"{e"^(string_of_int i_0)^"} = "^(string_of_float pr))*)
(*  )*)
(*;;*)


let rmGRLprev = ref (Model.create 10);;
let rmGRLcurr = ref mGRLzero;;
let mGRLtot = Model.create 1000;;

(* fill in GRL^k *)
for k = 1 to 100 do
  prerr_endline("k="^(string_of_int k));

  Model.clear !rmGRLprev;
  rmGRLprev := !rmGRLcurr;
  rmGRLcurr := Model.create 1000;

  Model.foreach !rmGRLprev
    (fun (d,l_,c_,i_) (l_0k,c_0k,i_0k) prGRL ->
      Model.foreach_given mG0 ("l",d,l_0k,c_0k,i_0k)
        (fun (l_0k0,c_0k0,i_0k0) prG0 ->
          Model.add !rmGRLcurr (d,l_,c_,i_) (l_0k0,c_0k0,i_0k0) (prGRL *. prG0);
          Model.add mGRLtot    (d,l_,c_,i_) (l_0k0,c_0k0,i_0k0) (prGRL *. prG0)
        ) 
    );

  (* echo out GRL^k *)
  Model.foreach !rmGRLcurr
    (fun (d_,l_,c_,i_) (l_0,c_0,i_0) pr ->
      print_endline ("GRLk "^d_^" "^l_^":"^c_^"{e"^(string_of_int i_)^"} : "^l_0^":"^c_0^"{e"^(string_of_int i_0)^"} = "^(string_of_float pr))
    )
done
;;


(*let hGRLstar = Hashtbl.create 1000;;*)
(*let hGRLplus = Hashtbl.create 1000;;*)



(*
(* write loop *)
(*Model.foreach mA*)
(*  (fun (l_,c_) i_ pr ->  *)
(*    print_endline ("A : "^l_^":"^c_^"{e"^(string_of_int i_)^"} = "^(string_of_float pr))*)
(*  );*)
Model.foreach mM
  (fun (u_,d_,l_,c_,i_) (l0,c0,l1,c1) pr ->  
    print_endline ("M "^u_^" "^d_^" "^l_^":"^c_^"{e"^(string_of_int i_)^"} : "^l0^":"^c0^" "^l1^":"^c1^" = "^(string_of_float pr))
  );
Model.foreach mL
  (fun (l_i,i_) i_i pr ->  
    print_endline ("L "^l_i^" e"^(string_of_int i_)^" : e"^(string_of_int i_i)^" = "^(string_of_float pr))
  );
Model.foreach mH
  (fun (c,i) h pr ->  
    print_endline ("H "^c^" e"^(string_of_int i)^" : "^h^" = "^(string_of_float pr))
  )
;;
*)
